-- level.lua
local lg = love.graphics
local currentShip = love.filesystem.load("maps/perseus")()

local timer = require "timer"

level = {}

function level.load()

blinky = timer.new()

scale = 16

spawnX = currentShip.spawnX
spawnY = currentShip.spawnY

redblink = {150,0,0}
greenblink = {0,150,0}

-- centers view on the map
	offsetX = 32 - (lg.getWidth() - #currentShip.map[1] * 16) / 2
	offsetY = 32 - (lg.getHeight() - #currentShip.map * 16) / 2

tiles = {																-- map index n#
	{name = "floor", char = ".", color = {200,200,200}, passable = true},			-- 01
	{name = "wall", char = "-", color = {100,100,100}, passable = false},			-- 02
	{name = "wall", char = "/", color = {100,100,100}, passable = false},			-- 03
	{name = "wall", char = "\\", color = {100,100,100}, passable = false},			-- 04
	{name = "wall", char = "|", color = {100,100,100}, passable = false},			-- 05
	{name = "engine", char = "H", color = {150,150,150}, passable = false},			-- 06
	{name = "engine", char = "*", color = {200,250,250}, passable = false},			-- 07
}

objects = {
	{name = "terminal", char = "=", color = {150,150,200}, passable = false},		-- 01
	{name = "chair", char = "U", color = {200,150,150}, passable = true},			-- 02
	{name = "spawn point", char = "0", color = {150,200,150}, passable = false},	-- 03
	{name = "red blinky", char = ".", color = redblink, passable = false},			-- 04 	DOUBLE CHECK THESE ARE
	{name = "green blinky", char = ".", color = greenblink, passable = false}		-- 05 	ON THE RIGHT SIDES!
}

end

function level.update(dt)

	blinky:update(dt)

	blinky:every(2, function()
		blinky:script(function(wait)
			redblink = {255,0,0}
			wait(0.2)
			redblink = {150,0,0}
			wait(0.2)
			greenblink = {0,255,0}
			wait(0.2)
			greenblink = {0,150,0}
		end)
	end)

end

function level.draw()

	local x, y, m, o

	for y = 1, #currentShip.map do
	
	m = currentShip.map[y]

		for x = 1, #m do
			if m[x] ~= 0 then
				lg.setColor(tiles[m[x]].color)
				lg.print(tiles[m[x]].char, x * scale, y * scale)
			end
	  	end
	end

	for y = 1, #currentShip.objects do

	o = currentShip.objects[y]

		for x = 1, #o do
			if o[x] ~= 0 then
				lg.setColor(0,0,0)
				lg.rectangle("fill", x * scale, y * scale, scale, scale)
				lg.setColor(objects[o[x]].color)
				lg.print(objects[o[x]].char, x * scale, y * scale)
			end

		end
	end

end

return level